module World(module WorldBase, module World)
where

import WorldBase
import Physics


-- Creates a scene from the ambient lighting, a list of objects, 
-- a list of lights and a voxel containing the scene.
mkScene :: Colour -> [Object] -> [Light] -> Voxel -> Scene
mkScene ambient objs lights voxel   = 
 Scene octTree (findMinSize octTree) ambient lights
 where
  octTree = mkOctTree voxel objs 
  -- Finds the minimum sized voxel in an OctTree and returns its length

-- |Takes a point and a voxel and returns the index of the sub-octant the 
-- point is in. Octants are numbered as follows.
-- Front face: 2 3    Backface: 6 7  
--             0 1              4 5 
getOctantIndex :: Point -> Voxel -> Int
getOctantIndex = error "World.getOctantIndex is undefined"


-- | Takes a Voxel and returns a list containing eight voxels which sub-divide
-- the voxel. The voxels should be in order of their index.
getOctants :: Voxel -> [Voxel]
getOctants = error "World.getOctants is undefined"


-- |Gets the leaf of the octTree containing a point
-- Precondition: point must be within the scene
getLeafContaining :: Point -> Scene -> OctTree 
getLeafContaining = error "World.getLeafContaining is undefined"


-- | findMinSize takes an OctTree and finds the size of the smallest
--   leaf within it.
findMinSize :: OctTree -> Distance
findMinSize = error "World.findMinSize is undefined"


-- |Takes a voxel that contains the whole scene and a list of objects
-- and creates an OctTree such that each node contains at
-- most maxObjects objects. 
mkOctTree :: Voxel -> [Object] -> OctTree
mkOctTree = error "World.mkOctTree is undefined"
